// Copyright 2017 The Johns Hopkins University Applied Physics Laboratory.
// Licensed under the MIT License. See LICENSE.txt in the project root for full license information.



#include <eopcc/grid_structs.hpp>

// #include <opencv2/core.hpp>
// #include <opencv2/highgui.hpp>


// namespace eopcc {

// void WriteImage(GridModel<double>& grid_model, const std::string filename) {
//     GridModel<double> temp = grid_model;


//     const cv::Mat temp_mat(grid_model.dimY(), grid_model.dimX(), CV_64FC1, grid_model.grid.data());
//     cv::Mat out_mat;

//     double max_val, min_val;
//     cv::minMaxLoc(temp_mat, &min_val, &max_val);

//     temp_mat.convertTo(out_mat, CV_8U, 255.0/(max_val - min_val), -min_val * 255.0/(max_val - min_val));
//     cv::imwrite(filename, out_mat);
// }

// void FillGridHoles(GridModel<double>& grid_model, GridModel<int>& counts, bool fill, double fill_val) {
//     std::pair<int, int> window_size(3,3);

//     for (size_t y=0; y < grid_model.dimY(); ++y) {
//         for (size_t x=0; x < grid_model.dimX(); ++x) {
//             if (counts(x,y) == 0) {
//                 bool patched = grid_model.patchHole(x, y, window_size, counts);

//                 if (!patched && fill) {
//                     grid_model(x,y) = fill_val;
//                 }
//             }
//         }
//     }
// }

// GridModel<int> CountGrid(const PointCloud& point_cloud, const GridModel<double>::spacing_t& grid_spacing) {
//     assert(point_cloud.valid());

//     Extent extent = point_cloud.extent;
//     GridModel<int> counts(extent, grid_spacing);
//     counts.setAll(0);

//     for (unsigned int chunk=0; chunk < point_cloud.num_chunks(); ++chunk) {
//         for (size_t i=0; i < point_cloud.chunk_size(chunk); ++i) {
//             int x_index = (point_cloud.x(chunk, i) - extent.min_x)/counts.spacingX();
//             int y_index = (point_cloud.y(chunk, i) - extent.min_y)/counts.spacingY();

//             counts(x_index, y_index) += 1;
//         }
//     }

//     return counts;
// }

// GridModel<double> MaxHeightGrid(const ChunkedPointCloud& point_cloud, const ChunkedData<double>& agl, const GridModel<double>::spacing_t& grid_spacing) {
//     assert(point_cloud.valid());

//     Extent extent = point_cloud.extent;
//     GridModel<double> max_height_grid(extent, grid_spacing);
//     max_height_grid.setAll(-std::numeric_limits<double>::max());

//     for (unsigned int chunk=0; chunk < point_cloud.num_chunks(); ++chunk) {
//         for (size_t i=0; i < point_cloud.chunk_size(chunk); ++i) {
//             int x_index = (point_cloud.x(chunk, i) - extent.min_x)/max_height_grid.spacingX();
//             int y_index = (point_cloud.y(chunk, i) - extent.min_y)/max_height_grid.spacingY();

//             max_height_grid(x_index, y_index) = std::max(max_height_grid(x_index, y_index), agl(chunk, i));
//         }
//     }

//     return max_height_grid;
// }

// GridModel<double> MinHeightGrid(const ChunkedPointCloud& point_cloud, const ChunkedData<double>& agl, const GridModel<double>::spacing_t& grid_spacing) {
//     assert(point_cloud.valid());

//     Extent extent = point_cloud.extent;
//     GridModel<double> min_height_grid(extent, grid_spacing);
//     min_height_grid.setAll(std::numeric_limits<double>::max());

//     for (unsigned int chunk=0; chunk < point_cloud.num_chunks(); ++chunk) {
//         for (size_t i=0; i < point_cloud.chunk_size(chunk); ++i) {
//             int x_index = (point_cloud.x(chunk, i) - extent.min_x)/min_height_grid.spacingX();
//             int y_index = (point_cloud.y(chunk, i) - extent.min_y)/min_height_grid.spacingY();

//             min_height_grid(x_index, y_index) = std::min(min_height_grid(x_index, y_index), agl(chunk, i));
//         }
//     }

//     return min_height_grid;
// }

// GridModel<double> VerticalVarGrid(const ChunkedPointCloud& point_cloud, const GridModel<double>& min_h, const ChunkedData<double>& agl,
//                                   const GridModel<double>::spacing_t& grid_spacing) {
//     assert(point_cloud.valid());

//     Extent extent = point_cloud.extent;
//     GridModel<int> return_count(extent, grid_spacing);
//     GridModel<int> fitting_count(extent, grid_spacing);
//     return_count.setAll(0);
//     fitting_count.setAll(0);

//     for (unsigned int chunk=0; chunk < point_cloud.num_chunks(); ++chunk) {
//         for (size_t i=0; i < point_cloud.chunk_size(chunk); ++i) {
//             int x_index = (point_cloud.x(chunk, i) - extent.min_x)/return_count.spacingX();
//             int y_index = (point_cloud.y(chunk, i) - extent.min_y)/return_count.spacingY();

//             if (agl(chunk, i) < 10 + min_h(x_index, y_index)) {
//                 return_count(x_index, y_index) += 1;
//             }

//             if (agl(chunk, i) < 0.5 + min_h(x_index, y_index)) {
//                 fitting_count(x_index, y_index) += 1;
//             }
//         }
//     }

//     GridModel<double> vertical_var_grid(extent, grid_spacing);

//     for (size_t i=0; i < vertical_var_grid.grid.size(); ++i) {
//         if (return_count.grid[i])
//             vertical_var_grid.grid[i] = ((double) fitting_count.grid[i]) / return_count.grid[i];
//     }

//     return vertical_var_grid;
// }


// GridModel<double> AttributeToVarGrid(const GridModel<double>& mean_grid, const ChunkedPointCloud& point_cloud,
//                                      const ChunkedData<double>& point_attr,
//                                      const GridModel<double>::spacing_t& grid_spacing, bool norm=false) {
//     assert(point_cloud.valid());

//     double scale, shift;
//     double min_v, max_v;

//     if (norm) {
//         auto bounds = CalculateBounds<double>(point_attr.begin(), point_attr.end(), ProcessingOptions());
//         scale = std::get<1>(bounds) - std::get<0>(bounds);
//         shift = std::get<0>(bounds);

//         min_v = std::get<0>(bounds);
//         max_v = std::get<1>(bounds);
//     } else {
//         scale = 1.0;
//         shift = 0;

//         min_v = -std::numeric_limits<double>::max();
//         max_v = std::numeric_limits<double>::max();
//     }

//     Extent extent = point_cloud.extent;
//     GridModel<double> attr_to_grid(extent, grid_spacing);
//     GridModel<int> count_grid(extent, grid_spacing);


//     for (unsigned int row=0; row < point_cloud.num_chunks(); ++row) {
//         for (size_t i=0; i < point_cloud.chunk_size(row); ++i) {
//             int x_index = (point_cloud.x(row, i) - extent.min_x)/attr_to_grid.spacingX();
//             int y_index = (point_cloud.y(row, i) - extent.min_y)/attr_to_grid.spacingY();

//             double attr_value = point_attr(row, i);
//             attr_value = std::min(max_v, attr_value);
//             attr_value = std::max(min_v, attr_value);

//             attr_to_grid(x_index, y_index) += std::pow((attr_value - shift)/scale - mean_grid(x_index, y_index), 2);
//             count_grid(x_index, y_index) += 1;
//         }
//     }

//     // Normalize the attribute grid
//     for (size_t i=0; i < attr_to_grid.grid.size(); ++i) {
//         attr_to_grid.grid[i] /= count_grid.grid[i];
//     }

//     return attr_to_grid;
// }

// ChunkedData<float> GridToAttribute(const ChunkedPointCloud& point_cloud, const GridModel<double>& grid) {
//     ChunkedData<float> chunked_attr;
//     chunked_attr.resize(point_cloud.num_chunks(), point_cloud.x.chunk_sizes());

//     Extent extent = point_cloud.extent;

//     for (unsigned int row=0; row < point_cloud.num_chunks(); ++row) {
//         for (size_t i=0; i < point_cloud.chunk_size(row); ++i) {
//             int x_index = (point_cloud.x(row, i) - extent.min_x)/grid.spacingX();
//             int y_index = (point_cloud.y(row, i) - extent.min_y)/grid.spacingY();

//             chunked_attr(row, i) = grid(x_index, y_index);
//         }
//     }

//     return chunked_attr;
// }


// GridModel<double> AttributeToGrid(const ChunkedPointCloud& point_cloud, const ChunkedData<double>& point_attr,
//                                   const GridModel<double>::spacing_t& grid_spacing, bool norm=false) {
//     assert(point_cloud.valid());

//     double scale, shift;
//     double min_v, max_v;

//     if (norm) {
//         auto bounds = CalculateBounds<double>(point_attr.begin(), point_attr.end(), ProcessingOptions());
//         scale = std::get<1>(bounds) - std::get<0>(bounds);
//         shift = std::get<0>(bounds);

//         min_v = std::get<0>(bounds);
//         max_v = std::get<1>(bounds);
//     } else {
//         scale = 1.0;
//         shift = 0;

//         min_v = -std::numeric_limits<double>::max();
//         max_v = std::numeric_limits<double>::max();
//     }

//     Extent extent = point_cloud.extent;
//     GridModel<double> attr_to_grid(extent, grid_spacing);
//     GridModel<int> count_grid(extent, grid_spacing);


//     for (unsigned int row=0; row < point_cloud.num_chunks(); ++row) {
//         for (size_t i=0; i < point_cloud.chunk_size(row); ++i) {
//             int x_index = (point_cloud.x(row, i) - extent.min_x)/attr_to_grid.spacingX();
//             int y_index = (point_cloud.y(row, i) - extent.min_y)/attr_to_grid.spacingY();

//             double attr_value = point_attr(row, i);
//             attr_value = std::min(max_v, attr_value);
//             attr_value = std::max(min_v, attr_value);

//             attr_to_grid(x_index, y_index) += (attr_value - shift)/scale;
//             count_grid(x_index, y_index) += 1;
//         }
//     }

//     // Normalize the attribute grid
//     for (size_t i=0; i < attr_to_grid.grid.size(); ++i) {
//         attr_to_grid.grid[i] /= count_grid.grid[i];
//     }

//     return attr_to_grid;
// }

// GridModel<double> AglToGrid(const ChunkedPointCloud& point_cloud, const ChunkedData<double> agl,
//                             const GridModel<double>::spacing_t& grid_spacing) {
//     assert(point_cloud.valid());

//     Extent extent = point_cloud.extent;
//     GridModel<double> agl_to_grid(extent, grid_spacing);
//     GridModel<int> count_grid(extent, grid_spacing);


//     for (unsigned int row=0; row < point_cloud.num_chunks(); ++row) {
//         for (size_t i=0; i < point_cloud.chunk_size(row); ++i) {
//             int x_index = (point_cloud.x(row, i) - extent.min_x)/agl_to_grid.spacingX();
//             int y_index = (point_cloud.y(row, i) - extent.min_y)/agl_to_grid.spacingY();

//             agl_to_grid(x_index, y_index) += point_cloud.z(row, i) - agl(row, i);
//             count_grid(x_index, y_index) += 1;
//         }
//     }

//     // Normalize the attribute grid
//     for (size_t i=0; i < agl_to_grid.grid.size(); ++i) {
//         agl_to_grid.grid[i] /= count_grid.grid[i];
//     }

//     return agl_to_grid;
// }

// GridModel<int> GroundReturnCount(const ChunkedPointCloud& point_cloud, const ChunkedData<double>& agl,
//                                  const GridModel<double>::spacing_t& grid_spacing) {
//     assert(point_cloud.valid());

//     Extent extent = point_cloud.extent;
//     GridModel<int> counts(extent, grid_spacing);
//     counts.setAll(0);

//     for (unsigned int chunk=0; chunk < point_cloud.num_chunks(); ++chunk) {
//         for (size_t i=0; i < point_cloud.chunk_size(chunk); ++i) {
//             int x_index = (point_cloud.x(chunk, i) - extent.min_x)/counts.spacingX();
//             int y_index = (point_cloud.y(chunk, i) - extent.min_y)/counts.spacingY();

//             if (agl(chunk, i) < 0.5 && agl(chunk, i) > -0.5)
//                 counts(x_index, y_index) += 1;
//         }
//     }

//     return counts;
// }

// GridModel<int> WaterCells(GridFeatures& grid_features) {
//     GridModel<int> water_grid(grid_features.counts.dimX(),
//                               grid_features.counts.dimY(),
//                               grid_features.counts.spacing());

//     for (size_t y=0; y < grid_features.counts.dimY(); ++y) {
//         for (size_t x=0; x < grid_features.counts.dimX(); ++x) {
//             int is_water = 0;

//             if (grid_features.counts(x,y) <= grid_features.counts.spacingX()*grid_features.counts.spacingY()*0.1) {
//                 is_water = 2;
//             } else if (grid_features.vv(x,y) > 0.90 && grid_features.min_h(x,y) < 0.5
//                         && grid_features.ground_counts(x,y) <= grid_features.counts.spacingX()*grid_features.counts.spacingY()*3) {
//                 is_water = 1;
//             }

//             water_grid(x,y) = is_water;
//         }
//     }

//     return water_grid;
// }

// GridModel<int> BuildingCells(GridFeatures& grid_features) {
//     GridModel<int> building_grid(grid_features.counts.dimX(),
//                                  grid_features.counts.dimY(),
//                                  grid_features.counts.spacing());

//     for (size_t y=0; y < grid_features.counts.dimY(); ++y) {
//         for (size_t x=0; x < grid_features.counts.dimX(); ++x) {
//             int is_building = 0;

//             if (grid_features.ground_counts(x,y) <= grid_features.counts.spacingX()*grid_features.counts.spacingY()*0.0
//                 && grid_features.min_h(x,y) > 2.5
//                 && grid_features.ndvi(x,y) < -0.05) {
//                 is_building = 2;
//             } else if (grid_features.ndvi(x,y) < 0.15
//                         && grid_features.max_h(x,y) > 2.5) {
//                 is_building = 1;
//             }


//             building_grid(x,y) = is_building;
//         }
//     }

//     return building_grid;
// }

// GridModel<int> VegCells(GridFeatures& grid_features) {
//     GridModel<int> veg(grid_features.counts.dimX(),
//                        grid_features.counts.dimY(),
//                        grid_features.counts.spacing());

//     for (size_t y=0; y < grid_features.counts.dimY(); ++y) {
//         for (size_t x=0; x < grid_features.counts.dimX(); ++x) {
//             int is_veg = 0;

//             if (grid_features.ndvi(x,y) > 0.10 && grid_features.intensity(x,y) > 0.6) {
//                 is_veg = 1;
//             } else if (grid_features.ndvi(x,y) > 0.15 && grid_features.max_h(x,y) > 0.8
//                 && grid_features.max_h(x,y) <= 3) {
//                 is_veg = 2;
//             }

//             veg(x,y) = is_veg;
//         }
//     }

//     return veg;
// }

// GridModel<int> LowICCells(GridFeatures& grid_features) {
//     GridModel<int> lowic(grid_features.counts.dimX(),
//                          grid_features.counts.dimY(),
//                          grid_features.counts.spacing());

//     for (size_t y=0; y < grid_features.counts.dimY(); ++y) {
//         for (size_t x=0; x < grid_features.counts.dimX(); ++x) {
//             int is_lowic = 0;

//             bool multi_returns = grid_features.max_h(x,y) - grid_features.min_h(x,y) > 1;

//             if (grid_features.max_h(x,y) < 2) {
//                 if (grid_features.ndvi(x,y) < 0.075) {
//                     if (grid_features.intensity(x,y) < 0.3) {
//                         is_lowic = 3;
//                     } else {
//                         is_lowic = 2;
//                     }
//                 } else if (grid_features.ndvi(x,y) < 0.15) {
//                     is_lowic = 1;
//                 }
//             }

//             lowic(x,y) = is_lowic;
//         }
//     }

//     return lowic;
// }


// GridModel<int> TreeCells(GridFeatures& grid_features) {
//     GridModel<int> tree(grid_features.counts.dimX(),
//                         grid_features.counts.dimY(),
//                         grid_features.counts.spacing());

//     for (size_t y=0; y < grid_features.counts.dimY(); ++y) {
//         for (size_t x=0; x < grid_features.counts.dimX(); ++x) {
//             int is_tree = 0;

//             bool tree_returns = (grid_features.ground_counts(x,y) == 0) || grid_features.max_h(x,y) - grid_features.min_h(x,y) > 3;

//             if (grid_features.max_h(x,y) > 3 && tree_returns) {
//                 if (grid_features.ndvi(x,y) > 0.15) {
//                     is_tree = 2;
//                 }
//                 else {
//                     is_tree = 1;
//                 }
//             }
//             tree(x,y) = is_tree;
//         }
//     }

//     return tree;
// }


// GridModel<int> SimpleCellMerge(GridModel<int>& water, GridModel<int>& building, GridModel<int>& lowveg,
//                                 GridModel<int>& medveg, GridModel<int>& tree, GridModel<int>& road,
//                                 GridModel<int>& dirt) {
//     GridModel<int> merged_cells(water.dimX(),
//                                 water.dimY(),
//                                 water.spacing());

//     for (size_t y=0; y < water.dimY(); ++y) {
//         for (size_t x=0; x < water.dimX(); ++x) {
//             int merged_value = 0;

//             if (water(x,y) > 0) {
//                 merged_value = 1;
//             } else if (building(x,y) > 0) {
//                 merged_value = 2;
//             } else if (lowveg(x,y)) {
//                 merged_value = 3;
//             } else if (road(x,y)) {
//                 merged_value = 6;
//             } else if (dirt(x,y)) {
//                 merged_value = 5;
//             } else if (medveg(x,y)) {
//                 merged_value = 4;
//             } else if (tree(x,y)) {
//                 merged_value = 7;
//             }

//             merged_cells(x,y) = merged_value;
//         }
//     }

//     return merged_cells;
// }


// GridModel<int> GridExtractObjects(GridModel<int>& input_grid, std::list<GridObject>& objects, int object_value, bool fuzz_object) {
//     GridModel<int> id_grid(input_grid.dimX(),
//                            input_grid.dimY(),
//                            input_grid.spacing());
//     objects.clear();
//     id_grid.setAll(0);

//     int next_id = 20;

//     for (unsigned int y=0; y < input_grid.dimY(); ++y) {
//         for (unsigned int x=0; x < input_grid.dimX(); ++x) {
//             if (!id_grid(x,y) && input_grid(x,y) == object_value) {
//                 GridModel<int>::location_t first_loc = std::make_pair(x,y);

//                 GridObject obj;
//                 obj.fcell_x = x;
//                 obj.fcell_y = y;
//                 obj.num_cells = FillObject(first_loc, input_grid, object_value, id_grid, next_id, fuzz_object);
//                 obj.id = next_id;
//                 obj.object_value = object_value;
//                 next_id++;

//                 objects.push_back(obj);
//             }
//         }
//     }

//     return id_grid;
// }


// int FillObject(const GridModel<int>::location_t& first_loc, GridModel<int>& input_grid,
//                  int object_value, GridModel<int>& id_grid, int object_id, bool fuzz_object) {

//     std::queue<GridModel<int>::location_t> locs;
//     std::vector<GridModel<int>::location_t> adj_list;

//     adj_list.resize(4);
//     adj_list[0] = std::make_pair(1,0);
//     adj_list[1] = std::make_pair(-1,0);
//     adj_list[2] = std::make_pair(0,1);
//     adj_list[3] = std::make_pair(0,-1);

//     locs.push(first_loc);
//     int object_size = 1;

//     while(!locs.empty()) {
//         GridModel<int>::location_t loc = locs.front();
//         locs.pop();

//         for (int i=0; i < adj_list.size(); ++i) {
//             GridModel<int>::location_t adj_loc = std::make_pair(std::get<0>(loc) + std::get<0>(adj_list[i]),
//                                          std::get<1>(loc) + std::get<1>(adj_list[i]));

//             if (input_grid.valid_location(adj_loc)) {
//                 if (!id_grid(adj_loc) && (input_grid(adj_loc) == object_value)) {
//                     locs.push(adj_loc);
//                     id_grid(adj_loc) = object_id;
//                     object_size +=1;
//                 }
//                 if (fuzz_object && !id_grid(adj_loc) && input_grid(adj_loc) == (object_value - 1)) {
//                     locs.push(adj_loc);
//                     id_grid(adj_loc) = object_id;
//                     object_size +=1;
//                 }
//             }
//         }
//     }

//     return object_size;
// }


// void RemoveSmallObjects(GridModel<int>& input_grid, GridModel<int>& id_grid, std::list<GridObject>& objects, int size_threshold) {
//     auto iter = objects.begin();
//     auto iter_end = objects.end();
//     while (iter != iter_end) {
//         if ((*iter).num_cells < size_threshold) {
//             RemoveObject(input_grid, id_grid, (*iter));
//             iter = objects.erase(iter);
//         } else {
//             ++iter;
//         }
//     }
// }

// void RemoveObject(GridModel<int>& input_grid, GridModel<int>& id_grid, GridObject& object) {
//     std::queue<GridModel<int>::location_t> locs;
//     std::vector<GridModel<int>::location_t> adj_list;

//     adj_list.resize(4);
//     adj_list[0] = std::make_pair(1,0);
//     adj_list[1] = std::make_pair(-1,0);
//     adj_list[2] = std::make_pair(0,1);
//     adj_list[3] = std::make_pair(0,-1);

//     locs.push(std::make_pair(object.fcell_x, object.fcell_y));

//     while(!locs.empty()) {
//         GridModel<int>::location_t loc = locs.front();
//         locs.pop();

//         for (int i=0; i < adj_list.size(); ++i) {
//             GridModel<int>::location_t adj_loc = std::make_pair(std::get<0>(loc) + std::get<0>(adj_list[i]),
//                                          std::get<1>(loc) + std::get<1>(adj_list[i]));

//             if (input_grid.valid_location(adj_loc)) {
//                 if (id_grid(adj_loc) == object.id) {
//                     locs.push(adj_loc);
//                     id_grid(adj_loc) = 0;
//                     input_grid(adj_loc) = 0;
//                 }
//             }
//         }
//     }
// }

// void FuzzObjects(GridModel<int>& input_grid, GridModel<int>& id_grid, std::list<GridObject>& objects, int fuzz_threshold, int fuzz_distance) {
//     for (GridObject& obj : objects) {
//         FuzzObject(input_grid, id_grid, obj, fuzz_threshold, fuzz_distance);
//     }
// }

// void FuzzObject(GridModel<int>& input_grid, GridModel<int>& id_grid, GridObject& object, int fuzz_threshold, int fuzz_distance) {
//     std::queue<GridModel<int>::location_t> locs;
//     std::queue<double> distances;
//     std::vector<GridModel<int>::location_t> adj_list;

//     adj_list.resize(8);
//     adj_list[0] = std::make_pair(1,0);
//     adj_list[1] = std::make_pair(-1,0);
//     adj_list[2] = std::make_pair(0,1);
//     adj_list[3] = std::make_pair(0,-1);

//     adj_list[4] = std::make_pair(-1,-1);
//     adj_list[5] = std::make_pair(1,1);
//     adj_list[6] = std::make_pair(1,-1);
//     adj_list[7] = std::make_pair(-1,1);

//     locs.push(std::make_pair(object.fcell_x, object.fcell_y));
//     distances.push(0);

//     while(!locs.empty()) {
//         GridModel<int>::location_t loc = locs.front();
//         locs.pop();
//         double dist_value = distances.front();
//         distances.pop();

//         if (dist_value > fuzz_distance)
//             continue;

//         for (int i=0; i < adj_list.size(); ++i) {
//             GridModel<int>::location_t adj_loc = std::make_pair(std::get<0>(loc) + std::get<0>(adj_list[i]),
//                                          std::get<1>(loc) + std::get<1>(adj_list[i]));

//             if (input_grid.valid_location(adj_loc)) {
//                 if (input_grid(adj_loc) == object.object_value) {
//                     id_grid(adj_loc) = object.id;
//                     input_grid(adj_loc) = 0;

//                     locs.push(adj_loc);
//                     distances.push(0);
//                 } else if (input_grid(adj_loc) >= fuzz_threshold && id_grid(adj_loc) != object.id) {
//                     id_grid(adj_loc) = object.id;
//                     input_grid(adj_loc) = 0;

//                     double adj_dis = (i > 3) ? sqrt(2.0) : 1;

//                     locs.push(adj_loc);
//                     distances.push(dist_value + adj_dis);
//                 }
//             }
//         }
//     }
// }

// void ErodeGrid(GridModel<int>& grid, int erode_threshold, int erode_interations) {
//     for(int i=0; i < erode_interations; ++i) {
//         GridModel<int> temp_grid = grid;
//         for (unsigned int y=0; y < temp_grid.dimY(); ++y) {
//             for (unsigned int x=0; x < temp_grid.dimX(); ++x) {
//                 bool clear_val = false;

//                 if (temp_grid.valid_location(x, y-1) && temp_grid(x, y-1) < erode_threshold) {
//                     grid(x,y) = 0;
//                 } else if (grid.valid_location(x, y+1) && temp_grid(x, y+1) < erode_threshold) {
//                     grid(x,y) = 0;
//                 } else if (grid.valid_location(x-1, y) && temp_grid(x-1, y) < erode_threshold) {
//                     grid(x,y) = 0;
//                 } else if (grid.valid_location(x+1, y) && temp_grid(x+1, y) < erode_threshold) {
//                     grid(x,y) = 0;
//                 }
//             }
//         }
//     }
// }

// void FilterPixelNoise(GridModel<int>& grid_values) {
//     for (unsigned int y=0; y < grid_values.dimY(); ++y) {
//         for (unsigned int x=0; x < grid_values.dimX(); ++x) {
//             int pixel_value = grid_values(x,y);

//             if (grid_values.valid_location(x, y-1) &&
//                 grid_values.valid_location(x, y+1) &&
//                 grid_values.valid_location(x-1, y) &&
//                 grid_values.valid_location(x+1, y)) {

//                 bool replace = false;
//                 replace = grid_values(x, y-1) == grid_values(x, y+1);
//                 replace = replace && grid_values(x, y-1) == grid_values(x-1, y);
//                 replace = replace && grid_values(x-1, y) == grid_values(x+1, y);
//                 replace = replace && grid_values(x-1, y) != pixel_value;

//                 if (replace) {
//                     grid_values(x,y) = grid_values(x-1, y);
//                 }
//             }
//         }
//     }
// }


// static const int kNUM_CLASSES=8;
// void VotingClassFill(GridModel<int>& grid) {
//     int filled_cells = 1;

//     while (filled_cells) {
//         filled_cells = 0;
//         GridModel<int> temp_grid = grid;
//         for (int y=0; y < temp_grid.dimY(); ++y) {
//             for (int x=0; x < temp_grid.dimX(); ++x) {
//                 if(!temp_grid(x,y)) {
//                     std::array<double, kNUM_CLASSES> hist = {0};
//                     for (int dy=-1; dy <= 1; ++dy) {
//                         for (int dx=-1; dx <= 1; ++dx) {
//                             double weight = (abs(dx) == 1 && abs(dy) == 1) ? 1.0/1.41 : 1.0;

//                             if(temp_grid.valid_location(x+dx, y+dy) && temp_grid(x+dx, y+dy)){
//                                 hist[temp_grid(x+dx, y+dy)-1] += 1;
//                             }
//                         }
//                     }

//                     int max_loc = -1;
//                     int max_val = 1;
//                     for (int i=0; i < kNUM_CLASSES; ++i) {
//                         if (max_val < hist[i]) {
//                             max_val = hist[i];
//                             max_loc = i;
//                         }
//                     }

//                     if (max_val >= 0) {
//                         grid(x,y) = max_loc + 1;
//                         filled_cells += 1;
//                     }
//                 }
//             }
//         }
//     }
// }


// cv::Vec3b lulc_colors[8] = {
//     cv::Vec3b(0,0,0), // Black
//     cv::Vec3b(0xFF,0,0), // Bright Blue
//     cv::Vec3b(0x40,0x40,0xA0), // Bright Red
//     cv::Vec3b(0x40,0xAA,0x77), // Brownish Green
//     cv::Vec3b(0x72,0xCC,0x73), // Light Green
//     cv::Vec3b(0x5B,0x8E,0x9B), // Brown
//     cv::Vec3b(0x40,0x40,0x10), // Dark Blue-Gray
//     cv::Vec3b(0x44,0x7C,0x2B)  // Dark Green
// };

// void WriteLULC(GridModel<int>& lulc, const std::string filename) {
//     cv::Mat out_mat(lulc.dimY(), lulc.dimX(), CV_8UC3);

//     for (size_t y=0; y < lulc.dimY(); ++y) {
//         for (size_t x=0; x < lulc.dimX(); ++x) {
//             out_mat.at<cv::Vec3b>(y,x) = lulc_colors[lulc(x,y)];
//         }
//     }

//     cv::imwrite(filename, out_mat);
// }





// void AutomatedLC(ChunkedPointCloud& point_cloud, PointAttribute* output_attr, ChunkedData<double>& red, ChunkedData<double>& intensity,
//                   ChunkedData<double>& agl, ChunkedData<double>& ndvi, const LULCSettings& settings) {
//     output_attr->name = "Land Cover";

//     if (settings.grid_edge_size == 0) {
//         throw std::runtime_error("Invalid grid size of 0");
//     }

//     double grid_edge = settings.grid_edge_size;
//     auto grid_spacing = std::make_pair(grid_edge, grid_edge);

//     GridFeatures grid_features;

//     grid_features.counts = CountGrid(point_cloud, grid_spacing);
//     grid_features.max_h = MaxHeightGrid(point_cloud, agl, grid_spacing);
//     grid_features.min_h = MinHeightGrid(point_cloud, agl, grid_spacing);
//     grid_features.vv = VerticalVarGrid(point_cloud, grid_features.min_h, agl, grid_spacing);

//     //ChunkedData<double> ndvi;
//     //ProcessingOptions options;
//     //CalculateNDVI(red, intensity, &ndvi, options);
//     grid_features.ndvi = AttributeToGrid(point_cloud, ndvi, grid_spacing);
//     grid_features.intensity = AttributeToGrid(point_cloud, intensity, grid_spacing, true);
//     grid_features.agl = AglToGrid(point_cloud, agl, grid_spacing);
//     grid_features.ground_counts = GroundReturnCount(point_cloud, agl, grid_spacing);

//     GridModel<double> int_var = AttributeToVarGrid(grid_features.intensity, point_cloud, intensity,
//                                                     grid_spacing, true);

//     FillGridHoles(grid_features.max_h, grid_features.counts, true);
//     FillGridHoles(grid_features.min_h, grid_features.counts, true);
//     FillGridHoles(grid_features.agl, grid_features.counts, true);
//     FillGridHoles(grid_features.ndvi, grid_features.counts, true);
//     FillGridHoles(grid_features.vv, grid_features.counts, true);


//     //WriteImage(grid_features.max_h, "C:/Users/kurtzzd1/max_h.png");
//     //WriteImage(grid_features.min_h, "C:/Users/kurtzzd1/min_h.png");
//     //WriteImage(grid_features.vv, "C:/Users/kurtzzd1/vv.png");
//     //WriteImage(grid_features.ndvi, "C:/Users/kurtzzd1/ndvi.png");
//     //WriteImage(grid_features.agl, "C:/Users/kurtzzd1/agl.png");
//     //WriteImage(grid_features.intensity, "C:/Users/kurtzzd1/intensity.png");
//     //WriteImage(int_var, "C:/Users/kurtzzd1/int_var.png");

//     //WriteImage(grid_features.counts.convertTo<double>(), "C:/Users/kurtzzd1/counts.png");



//     GridModel<int> lowveg_grid = VegCells(grid_features);
//     GridModel<int> lowic_grid = LowICCells(grid_features);

//     FilterPixelNoise(lowveg_grid);
//     FilterPixelNoise(lowic_grid);

//     std::list<GridObject> objects;
//     GridModel<int> tree_extract;

//     GridModel<int> building_extract;
//     GridModel<int> water_extract;
//     GridModel<int> veg_extract;
//     GridModel<int> medveg_extract;
//     GridModel<int> road_extract;
//     GridModel<int> dirt_extract;

//     if (settings.detect_buildings) {
//         GridModel<int> building_grid = BuildingCells(grid_features);
//         FilterPixelNoise(building_grid);

//         building_extract = GridExtractObjects(building_grid, objects, 2, false);
//         RemoveSmallObjects(building_grid, building_extract, objects, 15/(grid_edge*grid_edge));
//         FuzzObjects(building_grid, building_extract, objects, 1, 3/grid_edge);
//         //WriteImage(building_grid.convertTo<double>(), "C:/Users/kurtzzd1/building.png");
//     } else {
//         building_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         building_extract.setAll(0);
//     }

//     if (settings.detect_water) {
//         GridModel<int> water_grid = WaterCells(grid_features);
//         FilterPixelNoise(water_grid);

//         water_extract = GridExtractObjects(water_grid, objects, 2, false);
//         RemoveSmallObjects(water_grid, water_extract, objects, 25/(grid_edge*grid_edge));
//         FuzzObjects(water_grid, water_extract, objects, 0, 3);
//         ErodeGrid(water_extract, 0, 3);
//         //WriteImage(water_grid.convertTo<double>(), "C:/Users/kurtzzd1/water.png");
//     } else {
//         water_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         water_extract.setAll(0);
//     }

//     if (settings.detect_lowveg) {
//         veg_extract = GridExtractObjects(lowveg_grid, objects, 1, false);
//         RemoveSmallObjects(lowveg_grid, veg_extract, objects, 5/(grid_edge*grid_edge));
//         FuzzObjects(lowveg_grid, veg_extract, objects, 0, 1);
//         ErodeGrid(veg_extract, 1, 1);
//     } else {
//         veg_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         veg_extract.setAll(0);
//     }

//     if (settings.detect_medveg) {
//         medveg_extract = GridExtractObjects(lowveg_grid, objects, 2, false);
//         FuzzObjects(lowveg_grid, medveg_extract, objects, 0, 1);
//         ErodeGrid(medveg_extract, 1, 1);
//     } else {
//         medveg_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         medveg_extract.setAll(0);
//     }

//     if (settings.detect_asphalt) {
//         road_extract = GridExtractObjects(lowic_grid, objects, 3, false);
//         RemoveSmallObjects(lowic_grid, road_extract, objects, 2/(grid_edge*grid_edge));
//         FuzzObjects(lowic_grid, road_extract, objects, 0, 2);
//         ErodeGrid(road_extract, 1, 2);
//     } else {
//         road_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         road_extract.setAll(0);
//     }

//     if (settings.detect_dirt) {
//         dirt_extract = GridExtractObjects(lowic_grid, objects, 2, true);
//         RemoveSmallObjects(lowic_grid, dirt_extract, objects, 2/(grid_edge*grid_edge));
//         FuzzObjects(lowic_grid, dirt_extract, objects, 0, 2);
//         ErodeGrid(dirt_extract, 1, 2);
//     } else {
//         dirt_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         dirt_extract.setAll(0);
//     }

//     if(settings.detect_trees) {
//         GridModel<int> tree_grid = TreeCells(grid_features);
//         FilterPixelNoise(tree_grid);
//         tree_extract = GridExtractObjects(tree_grid, objects, 2, true);
//         //WriteImage(tree_extract.convertTo<double>(), "C:/Users/kurtzzd1/tree_extract.png");
//     } else {
//         tree_extract = GridModel<int>(point_cloud.extent, grid_spacing);
//         tree_extract.setAll(0);
//     }

//     //WriteImage(lowveg_grid.convertTo<double>(), "C:/Users/kurtzzd1/lowveg.png");
//     //WriteImage(tree_grid.convertTo<double>(), "C:/Users/kurtzzd1/tree.png");
//     //WriteImage(lowic_grid.convertTo<double>(), "C:/Users/kurtzzd1/lowic.png");

//     //WriteImage(building_extract.convertTo<double>(), "C:/Users/kurtzzd1/building_extract.png");
//     //WriteImage(veg_extract.convertTo<double>(), "C:/Users/kurtzzd1/veg_extract.png");
//     //WriteImage(road_extract.convertTo<double>(), "C:/Users/kurtzzd1/road_extract.png");
//     //WriteImage(medveg_extract.convertTo<double>(), "C:/Users/kurtzzd1/medveg_extract.png");



//     GridModel<int> merged_cells = SimpleCellMerge(water_extract, building_extract, veg_extract, medveg_extract,
//                                                   tree_extract, road_extract, dirt_extract);
//     VotingClassFill(merged_cells);

//     if (settings.write_to_file && !settings.filename.empty()) {
//         WriteLULC(merged_cells, settings.filename);
//     }


//     output_attr->chunked_values = GridToAttribute(point_cloud, merged_cells.convertTo<double>());
//     output_attr->datatype = PointAttribute::DataType::Chunked;
// }

// } // namespace eopcc